/*******************************************************************************
 * Copyright (c) 2014, 2019 Willink Transformations and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v2.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v20.html
 *
 * Contributors:
 *     E.D.Willink - initial API and implementation
 *******************************************************************************/
/**
 */
package test.hsv.HSVTree;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see test.hsv.HSVTree.HSVTreeFactory
 * @model kind="package"
 * @generated
 */
public interface HSVTreePackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "HSVTree";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.eclipse.org/qvt/examples/0.1/HSVTree";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "hsv";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	HSVTreePackage eINSTANCE = test.hsv.HSVTree.impl.HSVTreePackageImpl.init();

	/**
	 * Returns the meta object for class '{@link test.hsv.HSVTree.HSVNode <em>HSV Node</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>HSV Node</em>'.
	 * @see test.hsv.HSVTree.HSVNode
	 * @generated
	 */
	EClass getHSVNode();

	/**
	 * Returns the meta object for the container reference '{@link test.hsv.HSVTree.HSVNode#getParent <em>Parent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent</em>'.
	 * @see test.hsv.HSVTree.HSVNode#getParent()
	 * @see #getHSVNode()
	 * @generated
	 */
	EReference getHSVNode_Parent();

	/**
	 * Returns the meta object for the containment reference list '{@link test.hsv.HSVTree.HSVNode#getChildren <em>Children</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Children</em>'.
	 * @see test.hsv.HSVTree.HSVNode#getChildren()
	 * @see #getHSVNode()
	 * @generated
	 */
	EReference getHSVNode_Children();

	/**
	 * Returns the meta object for the attribute '{@link test.hsv.HSVTree.HSVNode#getHsv <em>Hsv</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Hsv</em>'.
	 * @see test.hsv.HSVTree.HSVNode#getHsv()
	 * @see #getHSVNode()
	 * @generated
	 */
	EAttribute getHSVNode_Hsv();

	/**
	 * Returns the meta object for the attribute '{@link test.hsv.HSVTree.HSVNode#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see test.hsv.HSVTree.HSVNode#getName()
	 * @see #getHSVNode()
	 * @generated
	 */
	EAttribute getHSVNode_Name();

	/**
	 * Returns the meta object for data type '{@link java.lang.String <em>HSV</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>HSV</em>'.
	 * @see java.lang.String
	 * @model instanceClass="java.lang.String"
	 * @generated
	 */
	EDataType getHSV();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	HSVTreeFactory getHSVTreeFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link test.hsv.HSVTree.impl.HSVNodeImpl <em>HSV Node</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see test.hsv.HSVTree.impl.HSVNodeImpl
		 * @see test.hsv.HSVTree.impl.HSVTreePackageImpl#getHSVNode()
		 * @generated
		 */
		EClass HSV_NODE = eINSTANCE.getHSVNode();

		/**
		 * The meta object literal for the '<em><b>Parent</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference HSV_NODE__PARENT = eINSTANCE.getHSVNode_Parent();

		/**
		 * The meta object literal for the '<em><b>Children</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference HSV_NODE__CHILDREN = eINSTANCE.getHSVNode_Children();

		/**
		 * The meta object literal for the '<em><b>Hsv</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HSV_NODE__HSV = eINSTANCE.getHSVNode_Hsv();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute HSV_NODE__NAME = eINSTANCE.getHSVNode_Name();

		/**
		 * The meta object literal for the '<em>HSV</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see java.lang.String
		 * @see test.hsv.HSVTree.impl.HSVTreePackageImpl#getHSV()
		 * @generated
		 */
		EDataType HSV = eINSTANCE.getHSV();

	}

} //HSVTreePackage
